"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _ModulesManager = _interopRequireDefault(require("./ModulesManager"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class Application {
  constructor(config) {
    this.config = config;
    this.modules = new _ModulesManager.default();
  }

  addModules(...modules) {
    modules.forEach(module => {
      Object.assign(module.config, this.config.get(`modules.${module.name}`, {}));
      this.modules.add(module);
    });
  }

  async boot() {
    await this.modules.setup();
  }

  async shutdown() {
    await this.modules.teardown();
  }

}

var _default = Application;
exports.default = _default;